protected/models/Project.php
<?php

/**
 * This is the model class for table "{{project}}".
 *
 * The followings are the available columns in table '{{project}}':
 * @property integer $id
 * @property integer $company_id
 * @property string $name
 * @property string $description
 * @property string $created_date
 */
class Project extends ActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return '{{project}}';
	}

	public function defaultScope()
	{
		return array(
			'alias' => 'project',
		);
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('company_id, name', 'required'),
			array('company_id', 'numerical'),
			array('name', 'length', 'max'=>255),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('id, company_id, name, description, created_date', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
			'company' => array(self::BELONGS_TO, 'Company', 'company_id'),
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'company_id' => 'Company',
			'name' => 'Name',
			'description' => 'Description',
			'created_date' => 'Created Date',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria = new CDbCriteria();

		$criteria->compare('id',$this->id);
		// always find projects from current company
		$criteria->compare('company_id',Yii::app()->user->company->id);
		$criteria->compare('name',$this->name,true);
		$criteria->compare('description',$this->description,true);
		$criteria->compare('created_date',$this->created_date,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return Project the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function afterDelete()
	{
		$criteria = new CDbCriteria();
		$criteria->compare('project_id', $this->id);

		$files = File::model()->findAll($criteria);
		foreach ($files as $file) {
			$file->delete();
		}
	}
}

protected/controllers/FileController.php
<?php

class FileController extends Controller
{
	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
			'accessControl', // perform access control for CRUD operations
		);
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
			array('allow',  // allow all users to perform 'index' and 'view' actions
				'actions'=>array('index','view', 'create', 'update', 'delete', 'history', 'copy', 'translationHistory'),
				'users'=>array('@'),
			),
			array('deny',  // deny all users
				'users'=>array('*'),
			),
		);
	}

	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{
		$model = $this->loadModel($id);
		$model->fetchLanguagesList();

		if (Yii::app()->request->getPost('translations') !== null || Yii::app()->request->getPost('translationsToRemove') !== null) {
			$translationData = Yii::app()->request->getPost('translations', array());
			$translationsToRemove = Yii::app()->request->getPost('translationsToRemove', array());

			if ($model->saveTranslations($translationData) === true) {
				$criteria = new CDbCriteria();
				$criteria->addInCondition('id', $translationsToRemove);

				$translationsToRemove = Translation::model()->findAll($criteria);

				foreach ($translationsToRemove as $translationToRemove) {
					$translationToRemove->delete();
				}

				$criteria = new CDbCriteria();
				$criteria->compare('system_version', $model->system_version);

				// if there are any translation history items added then the version should be increased.
				// This check is conducted to avoid gaps in system versions
				if (TranslationHistory::model()->count($criteria)) {
					$model->increaseVersion();
				}

				Yii::app()->user->setFlash('success', Yii::t('main', 'Saved'));

				// overwrite the translation data because needs translation can be missed in POST data if
				// it is turned off and then the button is active, since abscense of needs translation
				// is considered as needs translation
				$translationData = $model->getTranslationsData();
			} else {
				Yii::app()->user->setFlash('danger', Yii::t('main', reset($model->getErrors())[0]));
			}
		} else {
			$translationData = $model->getTranslationsData();
		}

		$this->render('view',array(
			'model'=>$model,
			'translationData' => $translationData,
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate()
	{
		$model = new File();
		if (Yii::app()->request->getQuery('project_id') !== null) {
			$model->project_id = Yii::app()->request->getQuery('project_id');

			if (Yii::app()->request->getPost('File') !== null) {
				$model->attributes = Yii::app()->request->getPost('File');
				$model->languagesList = array_keys(Yii::app()->request->getPost('Language', array()));
				if ($model->save()) {
					$this->redirect(array('file/' . $model->id . '/view'));
				}
			}

			$languages = Language::model()->findAll();

			$this->render('create',array(
				'model'=>$model,
				'languages' => $languages,
			));
		} else {
			$this->redirect(array('project/index'));
		}
	}

	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionUpdate($id)
	{
		$model = $this->loadModel($id);

		$model->fetchLanguagesList();

		if (Yii::app()->request->getPost('File') !== null) {
			$model->attributes = Yii::app()->request->getPost('File');
			$model->languagesList = array_keys(Yii::app()->request->getPost('Language', array()));

			if($model->save()) {
				$this->redirect(array('file/' . $model->id . '/view'));
			}
		}

		$languages = Language::model()->findAll();

		$this->render('update',array(
			'model'=>$model,
			'languages' => $languages,
		));
	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDelete($id)
	{
		$model = $this->loadModel($id);
		$model->delete();

		$this->redirect(array('project/' . $model->project_id . '/view'));
	}

	public function actionIndex()
	{
		$this->redirect(array('project/index'));
	}

	/**
	 * Shows difference between versions of a file.
	 */
	public function actionHistory($id)
	{
		$model = $this->loadModel($id);

		$criteria = new CDbCriteria();
		$criteria->select = 'DISTINCT system_version, version, created_date';
		$criteria->compare('file_id', $model->id);
		$criteria->order = 'created_date DESC';
		$translationsHistoryItems = TranslationHistory::model()->findAll($criteria);

		$versions = new stdClass();

		foreach ($translationsHistoryItems as $translationsHistoryItem) {
			$versions->{$translationsHistoryItem->system_version} = sprintf('v. %s#%05d (%s)', $translationsHistoryItem->version, $translationsHistoryItem->system_version, Yii::app()->dateTimeFormatter->toFormattedDateTime($translationsHistoryItem->created_date));
		}

		$versions = (array)$versions;

		if (Yii::app()->request->getQuery('from_version') !== null && Yii::app()->request->getQuery('to_version') !== null) {
			$diffs = $model->getDiff(Yii::app()->request->getQuery('from_version'), Yii::app()->request->getQuery('to_version'), (Yii::app()->request->getQuery('hide_unchanged_rows', '0') == '1'));

			$model->fetchLanguagesList();

			$this->render('diff-viewer',array(
				'model' => $model,
				'versions' => $versions,
				'translationData' => $diffs,
				'from_version' => Yii::app()->request->getQuery('from_version'),
				'to_version' => Yii::app()->request->getQuery('to_version'),
			));
		} else {
			$this->render('diff-viewer',array(
				'model' => $model,
				'versions' => $versions,
			));
		}
	}

	/**
	 * Copy an existing file into a new one
	 */
	public function actionCopy($id)
	{
		$model = $this->loadModel($id);

		$model->fetchLanguagesList();

		$criteria = new CDbCriteria();
		$criteria->select = 'DISTINCT system_version, version, created_date';
		$criteria->compare('file_id', $model->id);
		$criteria->order = 'created_date DESC';
		$translationsHistoryItems = TranslationHistory::model()->findAll($criteria);

		$versions = new stdClass();

		foreach ($translationsHistoryItems as $translationsHistoryItem) {
			$versions->{$translationsHistoryItem->system_version} = sprintf('v. %s#%05d (%s)', $translationsHistoryItem->version, $translationsHistoryItem->system_version, Yii::app()->dateTimeFormatter->toFormattedDateTime($translationsHistoryItem->created_date));
		}

		$versions = (array)$versions;

		if (Yii::app()->request->getQuery('version') !== null) {
			$model->fetchLanguagesList();

			$translationData = $model->getVersionTranslations(Yii::app()->request->getQuery('version'));

			$newModel = new File();
			$newModel->project_id = $model->project_id;
			$newModel->languagesList = $model->languagesList;
			$newModel->name = $model->name . ' - ' . Yii::t('main', 'Copy');

			if (Yii::app()->request->getPost('File') !== null) {
				if (Yii::app()->request->getPost('File') !== null) {
					$newModel->attributes = Yii::app()->request->getPost('File');
					if ($newModel->save() && $newModel->saveTranslations($translationData)) {
						Yii::app()->user->setFlash('success', Yii::t('main', 'Saved'));
						$this->redirect(array('file/' . $newModel->id . '/view'));
					} else {
						Yii::app()->user->setFlash('danger', Yii::t('main', 'An error coccured. Please try again later'));
					}
				}
			}

			$this->render('copy',array(
				'model' => $model,
				'newModel' => $newModel,
				'versions' => $versions,
				'translationData' => $translationData,
				'version' => Yii::app()->request->getQuery('version'),
			));
		} else {
			$this->render('copy',array(
				'model' => $model,
				'versions' => $versions,
			));
		}
	}

	public function actionTranslationHistory($id, $param)
	{
		$model = $this->loadModel($id);
		$model->fetchLanguagesList();

		$translationId = $param;

		if (Yii::app()->request->getQuery('language')) {
			$criteria = new CDbCriteria();
			$criteria->compare('translation_id', $translationId);
			$criteria->compare('file_id', $id);
			$criteria->compare('language_id', Yii::app()->request->getQuery('language'));
			$translationsHistory = TranslationHistory::model()->findAll($criteria);
		} else {
			$translationsHistory = array();
		}


		$this->render('translation-history',array(
			'model' => $model,
			'translationsHistory' => $translationsHistory,
			'language' => Yii::app()->request->getQuery('language')
		));
	}

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer $id the ID of the model to be loaded
	 * @return File the loaded model
	 * @throws CHttpException
	 */
	public function loadModel($id)
	{
		$criteria = new CDbCriteria();
		$criteria->together = true;
		$criteria->with = array('project', 'languages', 'fileToLanguages');
		$criteria->compare('project.company_id', Yii::app()->user->company->id);

		$model=File::model()->findByPk($id, $criteria);
		if($model===null)
			throw new CHttpException(404,'The requested page does not exist.');
		return $model;
	}
}

protected/controllers/ProjectController.php
<?php

class ProjectController extends Controller
{
	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
			'accessControl', // perform access control for CRUD operations
		);
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
			array('allow',  // allow all users to perform 'index' and 'view' actions
				'actions'=>array('index','view', 'create', 'update', 'delete'),
				'users'=>array('@'),
			),
			array('deny',  // deny all users
				'users'=>array('*'),
			),
		);
	}

	/**
	 * Manages all models.
	 */
	public function actionIndex()
	{
		$model=new Project('search');
		$model->unsetAttributes();  // clear any default values
		if(Yii::app()->request->getQuery('Project') !== null) {
			$model->attributes = Yii::app()->request->getQuery('Project');
		}

		$this->render('index',array(
			'model'=>$model,
		));
	}

	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{
		$fileModel = new File();
		$fileModel->unsetAttributes();
		$fileModel->project_id = $id;

		$this->render('view',array(
			'model'=>$this->loadModel($id),
			'fileModel' => $fileModel,
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate()
	{
		$model=new Project;

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if (Yii::app()->request->getPost('Project')) {
			$model->attributes = Yii::app()->request->getPost('Project');
			$model->company_id = Yii::app()->user->company->id;

			if ($model->save()) {
				$this->redirect(array('project/' . $model->id . '/view'));
			}
		}

		$this->render('create',array(
			'model'=>$model,
		));
	}

	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionUpdate($id)
	{
		$model=$this->loadModel($id);

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if (Yii::app()->request->getPost('Project')) {
			$model->attributes = Yii::app()->request->getPost('Project');
			if ($model->save()) {
				$this->redirect(array('project/' . $model->id . '/view'));
			}
		}

		$this->render('update',array(
			'model'=>$model,
		));
	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDelete($id)
	{
		$this->loadModel($id)->delete();

		// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
		if(!isset($_GET['ajax'])) {
			$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('index'));
		}
	}

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer $id the ID of the model to be loaded
	 * @return Project the loaded model
	 * @throws CHttpException
	 */
	public function loadModel($id)
	{
		$criteria = new CDbCriteria();
		$criteria->compare('project.company_id', Yii::app()->user->company->id);
		$model=Project::model()->findByPk($id, $criteria);
		if ($model===null) {
			throw new CHttpException(404,'The requested page does not exist.');
		}
		return $model;
	}
}

protected/views/project/_form.php
<div class="row">
    <div class="col-md-6 col-md-offset-3">
        <?php $form = $this->beginWidget('bootstrap.widgets.TbActiveForm'); ?>
            <fieldset>
                <?php 
                    echo $form->textFieldControlGroup($model, 'name');
                    echo $form->textareaControlGroup($model, 'description');
                    echo TbHtml::formActions(array(
                        TbHtml::submitButton($model->isNewRecord ? 'Create' : 'Save', array('color' => TbHtml::BUTTON_COLOR_PRIMARY)),
                    ));
                ?>
            </fieldset>
        <?php $this->endWidget(); ?>
    </div>
</div><!-- form -->

protected/views/project/create.php
<?php
	$this->breadcrumbs=array(
		Yii::t('main', 'Projects')=>array('project/index'),
		Yii::t('main', 'Create'),
	);

	echo TbHtml::pageHeader(Yii::t('main', 'Projects'), Yii::t('main', 'Create'));

	$this->renderPartial('_form', array('model'=>$model)); ?>

protected/views/project/index.php
<?php
    $this->pageTitle = Yii::t('main', 'Projects');

    $this->breadcrumbs=array(
        Yii::t('main', 'Projects'),
    );

    echo TbHtml::pageHeader(Yii::t('main', 'Projects'), '');

    echo CHtml::tag(
        'div', 
        array(
            'class' => 'text-right action-buttons'
        ),
        TbHtml::buttonGroup(array(
            array(
                'label' => TbHtml::icon(TbHtml::ICON_PLUS),
                'url' => array('project/create'),
                'htmlOptions' => array(
                    'title' => Yii::t('main', 'Create new project'),
                )
            )
        ))
    );

    $this->widget('bootstrap.widgets.TbGridView', array(
        'type' => TbHtml::GRID_TYPE_STRIPED,
        'dataProvider' => $model->search(),
        'columns' => array(
            array(
                'name' => 'id',
                'header' => '#',
                'htmlOptions' => array('style' =>'width: 60px'),
            ),
            array(
                'name' => 'name',
                'type' => 'raw',
                'value' => function($data) {
                    return TbHtml::link($data->name, array('project/' . $data->id . '/view'));
                },
            ),
            'description',
            array(
                'value' => function($data) {

                    echo TbHtml::buttonDropdown(
                        Yii::t('main', 'Options'),
                        array(
                            array('label' => Yii::t('main', 'Edit project data'), 'url' => array('project/' . $data->id . '/update')),
                            array('label' => Yii::t('main', 'Delete project'), 'url' => array('project/' . $data->id . '/delete')),
                        ), array(
                            'menuOptions' => array(
                                'pull' => TbHtml::PULL_RIGHT
                            )
                        )
                    );
                },
                'type' => 'raw',
                'htmlOptions' => array(
                    'class' => 'text-right',
                )
            ),
        )
    ));

protected/views/project/update.php
<?php
	$this->breadcrumbs=array(
		Yii::t('main', 'Projects')=>array('project/index'),
		$model->name=>array('project/' . $model->id . '/view'),
		Yii::t('main', 'Update project'),
	);

	echo TbHtml::pageHeader($model->name, Yii::t('main', 'Update'));

	$this->renderPartial('_form', array('model'=>$model));

protected/views/project/view.php
<?php
    $this->pageTitle = $model->name;

    $this->breadcrumbs=array(
        Yii::t('main', 'Projects')=>array('project/index'),
        $model->name,
    );

    echo TbHtml::pageHeader($model->name, Yii::t('main', 'Files'));

    echo CHtml::tag(
        'div', 
        array(
            'class' => 'text-right action-buttons'
        ),
        TbHtml::buttonGroup(array(
            array(
                'label' => TbHtml::icon(TbHtml::ICON_PLUS),
                'url' => array('file/create', 'project_id' => $model->id),
                'htmlOptions' => array(
                    'title' => Yii::t('main', 'Create new file'),
                )
            ),
            array(
                'label' => TbHtml::icon(TbHtml::ICON_PENCIL),
                'url' => array('project/' . $model->id . '/update'),
                'htmlOptions' => array(
                    'title' => Yii::t('main', 'Update project'),
                )
            ),
            array(
                'label' => TbHtml::icon(TbHtml::ICON_TRASH),
                'url' => array('project/' . $model->id . '/delete'),
                'color' => TbHtml::BUTTON_COLOR_WARNING,
                'htmlOptions' => array(
                    'title' => Yii::t('main', 'Delete project'),
                )
            ),
        ))
    );

    $this->widget('bootstrap.widgets.TbGridView', array(
        'type' => TbHtml::GRID_TYPE_STRIPED,
        'dataProvider' => $fileModel->search(),
        'columns' => array(
            array(
                'name' => 'id',
                'header' => '#',
                'htmlOptions' => array('style' =>'width: 60px'),
            ),
            array(
                'name' => 'name',
                'type' => 'raw',
                'value' => function($data) {
                    return TbHtml::link($data->name, array('file/' . $data->id . '/view'));
                },
            ),
            array(
                'header' => Yii::t('main', 'Rows'),
                'value' => '$data->translationsCount',
            ),
            array(
                'header' => Yii::t('main', 'Not translated phrases'),
                'value' => '$data->markedTranslationsCount',
            ),
            array(
                'name' => 'comment',
                'sortable'=>false,
            ),
            'version',
            array(
                'name' => 'system_version',
                'sortable'=>false,
            ),
            array(
                'value' => function($data) {

                    echo TbHtml::buttonDropdown(
                        Yii::t('main', 'Options'),
                        array(
                            array('label' => Yii::t('main', 'Edit translations'), 'url' => array('file/' . $data->id . '/view')),
                            array('label' => Yii::t('main', 'Copy file'), 'url' => array('file/' . $data->id . '/copy')),
                            array('label' => Yii::t('main', 'View file history'), 'url' => array('file/' . $data->id . '/history')),
                            array('label' => Yii::t('main', 'Edit file data'), 'url' => array('file/' . $data->id . '/update')),
                            array('label' => Yii::t('main', 'Delete file'), 'url' => array('file/' . $data->id . '/delete')),
                        ), array(
                            'url' => array('file/' . $data->id . '/diff'),
                            // 'color' => TbHtml::BUTTON_COLOR_INFO,
                            'menuOptions' => array(
                                'pull' => TbHtml::PULL_RIGHT
                            )
                        )
                    );
                },
                'type' => 'raw',
                'htmlOptions' => array(
                    'class' => 'text-right',
                )
            ),
        )
    ));